
#include <stdio.h>
#include <strings.h>
#include <assert.h>
#include "smartcard.h"

/*
 *  This program creates and initializes a new smartcard.
 */

int main(int argc, char** argv){
	char* cardFileName;
	FILE* fp;
	void* cardData;
	int   e;

	if(argc != 2){
		fprintf(stderr, "usage: %s cardFileName\n", argv[0]);
		return 1;
	}
	cardFileName = argv[1];
	
	/* allocate space for the card's persistent memory */
        cardData = malloc(CardDataSize);
	assert(cardData);

	/* initialize the persistent memory */
	/* for now, just zero-fill it */
	memset(cardData, 0, CardDataSize);

	/* open the card file */
	fp = fopen(cardFileName, "w");
	if(!fp){
		fprintf(stderr, "Error: couldn't open %s for writing.\n", 
			cardFileName);
		return 1;
	}

	/* write persistent memory to card file */
	e = fwrite(cardData, 1, CardDataSize, fp);
	assert(e == CardDataSize);
	fclose(fp);

	return 0;
}
