
#include <stdio.h>
#include <assert.h>
#include "smartcard.h"

/*
 *  This program prints the contents of a smartcard's persistent memory.
 *
 *  The assignment doesn't require this, but it will probably be useful to
 *      modify and use it, to debug and diagnose your other code.
 */


/* same typedef that appears in activateCard */
typedef struct {
	unsigned char canVote;
} * dataOnCard;


int main(int argc, char** argv){
	char*      cardFileName;
	FILE*      fp;
	dataOnCard cardData;
	int        e;

	if(argc != 2){
		fprintf(stderr, "usage: %s cardFileName\n", argv[0]);
		return 1;
	}
	cardFileName = argv[1];
	
	/* open the card file */
	fp = fopen(cardFileName, "r");
	if(!fp){
		fprintf(stderr, "Error: couldn't open %s for reading.\n", 
			cardFileName);
		return 1;
	}

	/* read in persistent memory from card file */
	cardData = malloc(CardDataSize);
	assert(cardData);
	e = fread(cardData, 1, CardDataSize, fp);
	assert(e == CardDataSize);
	fclose(fp);

	/* print out contents of persistent memory */
	printf("canVote = %d\n", cardData->canVote);
}
