
#include <stdio.h>
#include <assert.h>
#include "spawnCard.h"
#include "activateMachine.h"


/* 
 *   STUDENTS MAY NOT MODIFY THIS FILE.  Modify activateMachine.c instead.
 *
 *   Main program for voting machine.  This sets everything up properly and 
 *      then calls activateMachine, which does the actual work.
 *
 *   As part of the setup, this program invokes the smartcard program and
 *      sets up communication to it.
 */

static FILE* toCardFp;
static FILE* fromCardFp;


static void sendByte(int b){
	putc(b, toCardFp);
	fflush(toCardFp);
}

static int recvByte(void){
	return getc(fromCardFp);
}

static void allowVote(void){
	printf("allowed one vote\n");
}

int main(int argc, char** argv){
	char* cardFileName;

	if(argc != 2){
		fprintf(stderr, "usage: %s cardFileName\n", argv[0]);
		return 1;
	}
	cardFileName = argv[1];

	spawnCard(cardFileName, &toCardFp, &fromCardFp);

	activateMachine(sendByte, recvByte, allowVote);

	return 0;
}
	
