
#include <stdio.h>
#include <assert.h>
#include "smartcard.h"


/* 
 *   STUDENTS MAY NOT MODIFY THIS FILE.  Modify activateCard.c instead.
 *
 *   Main program for smartcard.  This sets everything up properly and 
 *      then calls activateCard, which does the actual work.
 *
 *   This program is (normally) not invoked directly.  Instead, it is 
 *      invoked by the encoder or machine programs, to simulate the insertion
 *      of the smartcard into those devices.
 */

static FILE* inFp;
static FILE* outFp;

static void sendByte(int b){
	putc(b, outFp);
	fflush(outFp);
}

static int recvByte(void){
	return getc(inFp);
}

int main(int argc, char** argv){
	char* cardFileName;
	FILE* fp;
	void* cardData;
	int   e;

	if(argc != 4){
		fprintf(stderr, "usage: %s cardFileName inFd outFd\n", argv[0]);
		return 1;
	}
	cardFileName = argv[1];
	inFp = fdopen(atoi(argv[2]), "r");
	outFp = fdopen(atoi(argv[3]), "w");
	
	fp = fopen(cardFileName, "r");
	if(!fp){
		fprintf(stderr, "Error: couldn't open %s for reading.\n", 
			cardFileName);
		return 1;
	}

	cardData = malloc(CardDataSize);
	assert(cardData);
	e = fread(cardData, 1, CardDataSize, fp);
	assert(e == CardDataSize);
	fclose(fp);

	activateCard(cardData, sendByte, recvByte);

	fp = fopen(cardFileName, "w");
	if(!fp){
		fprintf(stderr, "Error: couldn't open %s for writing.\n", 
			cardFileName);
		return 1;
	}
	e = fwrite(cardData, 1, CardDataSize, fp);
	assert(e == CardDataSize);
	fclose(fp);

	return 0;
}


