
/* CardDataSize is the size of the smartcard's persistent storage, in bytes. */
#define CardDataSize   65536


/* 
 *  activateCard gets called whenever the smartcard is inserted into another
 *     device.  
 *  <cardData> points to the smartcard's persistent storage, an array of
 *     CardDataSize bytes.  After activateCard returns, any changes to this
 *     data will be written back to persistent storage.
 *  Calling sendByte(b) will send a byte to the other device.
 *  recvByte waits for the next byte sent by the other device, and returns it.
 */

extern void activateCard(void* cardData,
			 void (*sendByte)(int),
			 int  (*recvByte)(void));
			 
